#!/usr/bin/env python
#
# Data Quality Checker also known as DQC
#
# Read the README.md for more detailed information
#
#       Barcelona Supercomputing Center - Centro Nacional de Supercomputacion
#       Earth Sciences Department - Computational Earth Sciences
#     
#     Authors: 
#       Joan Sala Calero (joan.sala@bsc.es)
#       Jesus Pena-Izquierdo (jesus.pena@bsc.es)

import sys
import warnings
warnings.filterwarnings('ignore')

# Local imports
from dqc_wrapper.utils.utils_forms import  *
from dqc_wrapper.utils.utils_bokeh import *
from dqc_wrapper.utils.utils_files import *
from dqc_wrapper.utils.utils_grib import *
from dqc_wrapper.utils.utils_stats import *

"""
Class: Valid ranges checks
---
- Generate histograms of data values per month
- If valid_min/valid_max are provided, raise error if outlier found
"""
class ValidRangesTest:

    def __init__(self, resdir, testname, files, varname, vmin, vmax, dt, forms_dir, cds_dataset, cds_variable):
        self.testid = 'test06-valid_ranges'
        self.logger = logging.getLogger(self.testid)
        self.output_plot_html = os.path.join(resdir, testname.replace('.ini', '-valid_ranges.html'))
        self.csv_hist = os.path.join(resdir, testname.replace('.ini', '-hist.csv'))
        self.csv_stats = os.path.join(resdir, testname.replace('.ini', '-stats.csv'))
        self.files = files
        self.varname = varname     
        self.datatype = dt
        self.stat_columns = [ 'Min', 'Max', 'Med', 'q1', 'q3', 'IQR' ]
        self.cds_variable = cds_variable
        self.cds_dataset = cds_dataset
        self.metadata = get_metadata(forms_dir, cds_dataset, cds_variable)

        # Automatic versus computed valid ranges
        self.estimated_valid_min = None
        self.estimated_valid_max = None
        try:
            self.valid_min = float(vmin)
        except:
            self.valid_min = None
        try:
            self.valid_max = float(vmax)
        except:
            self.valid_max = None

    """
    Hadley cell stats (90, 60, 30) absolute latitudes (polar, mid-latitude, hadley) - Remove NaN 
    """
    def get_hist_hadley_xarray(self, df_hist, hbins, ds, init, lat0, lat1, row, latid):
        arr = ds[self.varname].where((ds[latid] > lat0) & (ds[latid] <= lat1)).values
        arr = arr[~np.isnan(arr)]
        x, b = np.histogram(arr, bins=hbins)

        # Initialization vs sum
        if init==0:
            df_hist.loc[row] = x
        else:
            df_hist.loc[row] += x

        return x, [ arr.min(), arr.max() ]

    """
    Get Histogram bins initalization. 
    Number of bins + K = number of times (amplification of the histogram bins) 
    Initialization observed minmax
    """
    def get_bins_init(self, files, nbins=2000, Kmax=5, max_samples=24):

        # XARRAY (NetCDF)
        if files[0].endswith('.nc'):
            # Try to load data from the first file
            ds, errmsg = load_datafile(files[0])
            if errmsg != '':
                return None, None, None, errmsg

            # Load all data from all product types
            arr = get_variable(ds, self.varname)

        # ECCODES (GRIB)
        else:
            # Get a sample from every first message of every file [better, faster, stronger]
            arr = []

            # Avoid useless memory consumption (2 years or 24 months is good enough)
            if len(files) > max_samples:
                files = files[0:max_samples]

            for f in files:
                gf = GribFileCheck(f, dt=self.datatype)
                arr += gf.get_grib_first_values().tolist() # Get sample (of file X)

        # Return histogram initialization
        minv = np.min(arr)
        maxv = np.max(arr)
        dist = abs(maxv-minv)
        return np.histogram_bin_edges(arr, bins=nbins, range=(minv-Kmax*dist, maxv+Kmax*dist)), minv, maxv, ''

    """
    Main function
    """
    def check_valid_ranges(self):
       
        # Progress init
        i = 0
        n = len(self.files) # read/calc_stats

        # Store stats information per file (basename is the unique key and contains date)
        bn = [ os.path.basename(f) for f in self.files ] 
        df_stats = pd.DataFrame(index=bn, columns=self.stat_columns)

        # Init histogram bins with the first file
        hist_bins, minv, maxv, errmsg = self.get_bins_init(self.files)
        if errmsg != '':
            return 'err', errmsg

        # We keep statistics per hadley-cell, filename and total [order is relevant]
        hadley_cells = {
            'N_polar': [60, 90],
            'N_midlat': [30, 60],
            'N_hadley': [0, 30],
            'S_hadley': [-30, 0],
            'S_midlat': [-60, -30],
            'S_polar': [-90, -60]
        }
        df_hist = pd.DataFrame(
            index = bn + list(hadley_cells.keys()),
            columns = hist_bins[:-1]
        )
       
        # Generate histograms, store them in a dataframe
        ind = 0
        for f in self.files:
            # Progress update
            i+=1
            print_progress(i, n)              

            # NetCDF - read all datatypes individually
            if f.endswith('.nc'):
                # Load xarray dataset
                ds, errmsg = load_datafile(f)
                if errmsg != '':
                    return 'err', errmsg

                # Latitude histograms - subset and cumulative sum for 6-hadley cells
                latid = get_lat_name(ds)
                first = True

                for hc, lats in hadley_cells.items():
                    hc_hist, mnmx = self.get_hist_hadley_xarray(
                        df_hist, hist_bins, ds, ind,  lats[0],  lats[1], hc, latid
                    )

                    # Compute histogram (global/month) as sum of all latitude ranges (init vs accum)
                    if first:
                        xsum = hc_hist
                        minv = min(mnmx)
                        maxv = max(mnmx)
                    else:
                        xsum = sum([hc_hist, xsum])
                        minv = min(minv, mnmx)
                        maxv = max(maxv, mnmx)
            else:
                # All regions at once (more efficient) - message x message
                ds = GribFileCheck(f, dt=self.datatype)
                xsum, minv, maxv = ds.get_grib_hadley_regions(ind, hist_bins, df_hist)

            # Store general/full histogram
            df_hist.loc[os.path.basename(f)] = xsum

            # Compute stats (of the histogram - faster)
            df_stats.loc[os.path.basename(f)] = [ minv, maxv ] + get_basic_stats(xsum, hist_bins)
            
            # Next iteration
            del ds
            del xsum
            ind+=1

        # Compute total histogram        
        df_hist.loc['total'] = df_hist.sum().values
        
        # Save stats for future use
        df_hist.index.name = 'File'
        df_hist.to_csv(self.csv_hist)
        print('INFO: Saving histogram to {}'.format(self.csv_hist))
        df_stats.index.name = 'File'
        df_stats.to_csv(self.csv_stats)
        print('INFO: Saving stats to {}'.format(self.csv_stats))

        # Estimated valid_min/valid_max
        self.estimated_valid_min, self.estimated_valid_max = exhaustive_vmin_vmax(self.csv_hist)

        # Defaults
        res = ''
        msg_data = 'Data range: [from {} to  {}]{}'.format(
            format_float(min(df_stats['Min'])), format_float(max(df_stats['Max'])), self.metadata['unit'])
        msg_vr = 'Known physical plausible range [from {} to  {}]{}'.format(
            format_float(self.valid_min), format_float(self.valid_max), self.metadata['unit'])
        msg_est_vr = 'Estimated physical plausible range [from {} to  {}]{}'.format(
            format_float(self.estimated_valid_min), format_float(self.estimated_valid_max), self.metadata['unit']
            )

        # Unknown ranges for the variable
        if self.valid_min is None and self.valid_max is None:
            if self.estimated_valid_min is None and self.estimated_valid_max is None:
                res = 'err'
                msg = 'Physical plausible range unknown. Unable to estimate the physical plausible range.'
            else:
                res = check_vmin_vmax(df_stats, self.estimated_valid_min, self.estimated_valid_max, self.logger, res_val='warn')
                msg = '{}. {}. '.format(msg_data, msg_est_vr)

                # Conclusion plausible range
                if res == 'ok':
                    msg += 'No potential outliers found.'
                else:
                    msg += 'Estimation found potential outliers.'

        # Valid range estimation (only if defined, well-known variable limits)               
        else:
            res = check_vmin_vmax(df_stats, self.valid_min, self.valid_max, self.logger, res_val='err')
            msg = '{}. {}. '.format(msg_data, msg_vr)

            # Conclusion plausible range
            if res == 'ok':
                msg += 'No outliers found.'
            else:
                msg += 'Potential outliers found. Check log for details'

        # Final plots
        bp = BokehPlot(self.output_plot_html, self.csv_stats, self.csv_hist, self.cds_variable, self.cds_dataset,
                       self.valid_min, self.valid_max, self.estimated_valid_min, self.estimated_valid_max, self.metadata)
        bp.plot_histograms()
                
        # Final message
        if res == 'ok':
            self.logger.info(msg)
        elif res == 'warn':
            self.logger.warning(msg)
        else:
            self.logger.error(msg)

        return res, msg

    def main(self):
       
        # Do the actual work
        res, msg = self.check_valid_ranges()

        # Prepare output
        return { 
            'res': res, 
            'msg': msg,
            'plot': self.output_plot_html
        }    
    
if __name__ == '__main__':
    sys.exit()
